diff --git a/src/bin/initdb/initdb.c b/src/bin/initdb/initdb.c
index ab5cb7f0c1..5dc569c3a1 100644
--- a/src/bin/initdb/initdb.c
+++ b/src/bin/initdb/initdb.c
@@ -55,6 +55,10 @@
 #include <signal.h>
 #include <time.h>
 
+#ifdef USE_ICU
+#include <unicode/uloc.h>
+#endif
+
 #ifdef HAVE_SHM_OPEN
 #include "sys/mman.h"
 #endif
@@ -65,6 +69,7 @@
 #include "catalog/pg_collation_d.h"
 #include "common/file_perm.h"
 #include "common/file_utils.h"
+#include "common/pg_collation_fn_common.h"
 #include "common/restricted_token.h"
 #include "common/username.h"
 #include "fe_utils/string_utils.h"
@@ -144,6 +149,8 @@ static bool data_checksums = false;
 static char *xlog_dir = NULL;
 static char *str_wal_segment_size_mb = NULL;
 static int	wal_segment_size_mb;
+static char collprovider = '\0';
+static char *collversion = NULL;
 
 
 /* internal vars */
@@ -269,10 +276,15 @@ static char *escape_quotes(const char *src);
 static char *escape_quotes_bki(const char *src);
 static int	locale_date_order(const char *locale);
 static void check_locale_name(int category, const char *locale,
-				  char **canonname);
-static bool check_locale_encoding(const char *locale, int encoding);
+				  char **canonname, char collprovider);
+static bool check_locale_encoding(const char *locale, int encoding,
+								  char collprovider);
 static void setlocales(void);
 static void usage(const char *progname);
+#ifdef USE_ICU
+static char *check_icu_locale_name(const char *locale);
+#endif
+static void set_collation_version(void);
 void		setup_pgdata(void);
 void		setup_bin_paths(const char *argv0);
 void		setup_data_file_paths(void);
@@ -1407,10 +1419,27 @@ bootstrap_template1(void)
 	char	  **bki_lines;
 	char		headerline[MAXPGPATH];
 	char		buf[64];
+	char	   *lc_collate_full_name;
 
 	printf(_("running bootstrap script ... "));
 	fflush(stdout);
 
+	Assert(lc_collate);
+
+	lc_collate_full_name = get_full_collation_name(lc_collate, collprovider,
+												   collversion);
+
+	if (!lc_collate_full_name)
+		exit(1);				/* get_full_collation_name printed the error */
+
+	if (strlen(lc_collate_full_name) >= NAMEDATALEN)
+	{
+		fprintf(stderr,
+				_("%s: the full collation name \"%s\" is too long\n"),
+				progname, lc_collate_full_name);
+		exit(1);
+	}
+
 	bki_lines = readfile(bki_file);
 
 	/* Check that bki file appears to be of the right version */
@@ -1452,7 +1481,7 @@ bootstrap_template1(void)
 							  encodingid_to_string(encodingid));
 
 	bki_lines = replace_token(bki_lines, "LC_COLLATE",
-							  escape_quotes_bki(lc_collate));
+							  escape_quotes_bki(lc_collate_full_name));
 
 	bki_lines = replace_token(bki_lines, "LC_CTYPE",
 							  escape_quotes_bki(lc_ctype));
@@ -1494,6 +1523,7 @@ bootstrap_template1(void)
 	PG_CMD_CLOSE;
 
 	free(bki_lines);
+	free(lc_collate_full_name);
 
 	check_ok();
 }
@@ -2244,53 +2274,143 @@ locale_date_order(const char *locale)
  * the locale name, but typically it doesn't.)
  *
  * this should match the backend's check_locale() function
+ *
+ * Set collprovider to '\0' if category is not LC_COLLATE.
  */
 static void
-check_locale_name(int category, const char *locale, char **canonname)
+check_locale_name(int category, const char *locale, char **canonname,
+				  char collprovider)
 {
-	char	   *save;
-	char	   *res;
+	const char *save;
+	const char *res;
+	char	   *save_dup;
+	bool		use_libc PG_USED_FOR_ASSERTS_ONLY =
+		category != LC_COLLATE || collprovider == COLLPROVIDER_LIBC;
+	bool		use_icu =
+		category == LC_COLLATE && collprovider == COLLPROVIDER_ICU;
+	bool		failure = false;
+#ifdef USE_ICU
+	UErrorCode  status;
+	char	   *icu_locale;
+#endif
 
-	if (canonname)
-		*canonname = NULL;		/* in case of failure */
+	Assert(use_libc || use_icu);
 
-	save = setlocale(category, NULL);
-	if (!save)
+#ifndef USE_ICU
+	if (use_icu)
 	{
-		fprintf(stderr, _("%s: setlocale() failed\n"),
+		fprintf(stderr,
+				_("%s: ICU is not supported in this build\n"
+				  "You need to rebuild PostgreSQL using --with-icu.\n"),
 				progname);
 		exit(1);
 	}
+#endif
+
+	if (canonname)
+		*canonname = NULL;		/* in case of failure */
+
+#ifdef USE_ICU
+	if (use_icu)
+	{
+		save = uloc_getDefault();
+		if (!save)
+		{
+			fprintf(stderr, _("%s: ICU error: uloc_getDefault() failed\n"),
+					progname);
+			exit(1);
+		}
+	}
+	else
+#endif
+	{
+		/* use_libc */
+		save = setlocale(category, NULL);
+		if (!save)
+		{
+			fprintf(stderr, _("%s: setlocale() failed\n"),
+					progname);
+			exit(1);
+		}
+	}
 
 	/* save may be pointing at a modifiable scratch variable, so copy it. */
-	save = pg_strdup(save);
+	save_dup = pg_strdup(save);
 
 	/* for setlocale() call */
 	if (!locale)
 		locale = "";
 
 	/* set the locale with setlocale, to see if it accepts it. */
-	res = setlocale(category, locale);
+#ifdef USE_ICU
+	if (use_icu)
+	{
+		icu_locale = check_icu_locale_name(locale);
+		if (icu_locale == NULL && locale != NULL)
+		{
+			failure = true;
+			res = NULL;
+		}
+		else
+		{
+			status = U_ZERO_ERROR;
+			uloc_setDefault(icu_locale, &status);
+			res = uloc_getDefault();
+			failure = (U_FAILURE(status) || res == NULL);
+			if (icu_locale)
+				pfree(icu_locale);
+		}
+	}
+	else
+#endif
+	{
+		/* use_libc */
+		res = setlocale(category, locale);
+		failure = (res == NULL);
+	}
 
 	/* save canonical name if requested. */
 	if (res && canonname)
 		*canonname = pg_strdup(res);
 
 	/* restore old value. */
-	if (!setlocale(category, save))
+#ifdef USE_ICU
+	if (use_icu)
 	{
-		fprintf(stderr, _("%s: failed to restore old locale \"%s\"\n"),
-				progname, save);
-		exit(1);
+		status = U_ZERO_ERROR;
+		uloc_setDefault(save_dup, &status);
+		if (U_FAILURE(status))
+		{
+			fprintf(stderr, _("%s: ICU error: failed to restore old locale \"%s\"\n"),
+					progname, save_dup);
+			exit(1);
+		}
 	}
-	free(save);
+	else
+#endif
+	{
+		/* use_libc */
+		if (!setlocale(category, save_dup))
+		{
+			fprintf(stderr, _("%s: failed to restore old locale \"%s\"\n"),
+					progname, save_dup);
+			exit(1);
+		}
+	}
+	free(save_dup);
 
 	/* complain if locale wasn't valid */
-	if (res == NULL)
+	if (failure)
 	{
 		if (*locale)
-			fprintf(stderr, _("%s: invalid locale name \"%s\"\n"),
-					progname, locale);
+		{
+			if (category == LC_COLLATE)
+				fprintf(stderr, _("%s: invalid locale name \"%s\" (provider \"%s\")\n"),
+						progname, locale, get_collprovider_name(collprovider));
+			else
+				fprintf(stderr, _("%s: invalid locale name \"%s\"\n"),
+						progname, locale);
+		}
 		else
 		{
 			/*
@@ -2312,9 +2432,11 @@ check_locale_name(int category, const char *locale, char **canonname)
  * check if the chosen encoding matches the encoding required by the locale
  *
  * this should match the similar check in the backend createdb() function
+ *
+ * Set collprovider to '\0' if category is not LC_COLLATE.
  */
 static bool
-check_locale_encoding(const char *locale, int user_enc)
+check_locale_encoding(const char *locale, int user_enc, char collprovider)
 {
 	int			locale_enc;
 
@@ -2341,6 +2463,25 @@ check_locale_encoding(const char *locale, int user_enc)
 				progname);
 		return false;
 	}
+
+	if (collprovider == COLLPROVIDER_ICU)
+	{
+#ifdef USE_ICU
+		if (!is_encoding_supported_by_icu(user_enc))
+		{
+			fprintf(stderr, _("%s: selected encoding (%s) is not supported for ICU locales\n"),
+					progname, pg_encoding_to_char(user_enc));
+			return false;
+		}
+#else							/* not USE_ICU */
+		fprintf(stderr,
+				_("%s: ICU is not supported in this build\n"
+				  "You need to rebuild PostgreSQL using --with-icu.\n"),
+				progname);
+		exit(1);
+#endif							/* not USE_ICU */
+	}
+
 	return true;
 }
 
@@ -2352,16 +2493,22 @@ check_locale_encoding(const char *locale, int user_enc)
 static void
 setlocales(void)
 {
-	char	   *canonname;
-
-	/* set empty lc_* values to locale config if set */
+	char	   *canonname = NULL;
 
 	if (locale)
 	{
+		/*
+		 * Set up the collation provider if possible and canonicalize the locale
+		 * name.
+		 */
+		check_locale_collprovider(locale, &canonname, &collprovider, NULL);
+		if (!canonname)
+			exit(1);		/* check_locale_collprovider printed the error */
+		locale = canonname;
+
+		/* set empty lc_* values to locale config if set */
 		if (!lc_ctype)
 			lc_ctype = locale;
-		if (!lc_collate)
-			lc_collate = locale;
 		if (!lc_numeric)
 			lc_numeric = locale;
 		if (!lc_time)
@@ -2372,29 +2519,83 @@ setlocales(void)
 			lc_messages = locale;
 	}
 
+	if (lc_collate)
+	{
+		/*
+		 * Set up the collation provider if possible and canonicalize the locale
+		 * name.
+		 */
+		check_locale_collprovider(lc_collate, &canonname, &collprovider, NULL);
+		if (!canonname)
+			exit(1);		/* check_locale_collprovider printed the error */
+		lc_collate = canonname;
+	}
+	else if (canonname)
+	{
+		/* we have already canonicalized the locale name */
+		lc_collate = pstrdup(canonname);
+	}
+
 	/*
 	 * canonicalize locale names, and obtain any missing values from our
 	 * current environment
 	 */
 
-	check_locale_name(LC_CTYPE, lc_ctype, &canonname);
+	check_locale_name(LC_CTYPE, lc_ctype, &canonname, '\0');
 	lc_ctype = canonname;
-	check_locale_name(LC_COLLATE, lc_collate, &canonname);
+
+	/* we always check lc_collate for libc */
+	check_locale_name(LC_COLLATE, lc_collate, &canonname, COLLPROVIDER_LIBC);
+	if (lc_collate)
+		pfree(lc_collate);
 	lc_collate = canonname;
-	check_locale_name(LC_NUMERIC, lc_numeric, &canonname);
+
+	/* determine the collation provider if we haven't already done it */
+	if (!is_valid_nondefault_collprovider(collprovider))
+	{
+#ifdef USE_ICU
+		if (!locale_is_c(lc_collate))
+		{
+			collprovider = COLLPROVIDER_ICU;
+		}
+		else
+#endif
+		{
+			collprovider = COLLPROVIDER_LIBC;
+		}
+	}
+
+	Assert(is_valid_nondefault_collprovider(collprovider));
+
+	/* check lc_collate and lc_ctype for icu if we need it */
+	if (collprovider == COLLPROVIDER_ICU)
+	{
+		check_locale_name(LC_COLLATE, lc_collate, NULL, collprovider);
+		if (strcmp(lc_collate, lc_ctype) != 0)
+		{
+			fprintf(stderr,
+					_("%s: collations with different collate and ctype values are not supported by ICU\n"),
+					progname);
+			exit(1);
+		}
+	}
+
+	check_locale_name(LC_NUMERIC, lc_numeric, &canonname, '\0');
 	lc_numeric = canonname;
-	check_locale_name(LC_TIME, lc_time, &canonname);
+	check_locale_name(LC_TIME, lc_time, &canonname, '\0');
 	lc_time = canonname;
-	check_locale_name(LC_MONETARY, lc_monetary, &canonname);
+	check_locale_name(LC_MONETARY, lc_monetary, &canonname, '\0');
 	lc_monetary = canonname;
 #if defined(LC_MESSAGES) && !defined(WIN32)
-	check_locale_name(LC_MESSAGES, lc_messages, &canonname);
+	check_locale_name(LC_MESSAGES, lc_messages, &canonname, '\0');
 	lc_messages = canonname;
 #else
 	/* when LC_MESSAGES is not available, use the LC_CTYPE setting */
-	check_locale_name(LC_CTYPE, lc_messages, &canonname);
+	check_locale_name(LC_CTYPE, lc_messages, &canonname, '\0');
 	lc_messages = canonname;
 #endif
+
+	set_collation_version();
 }
 
 /*
@@ -2612,6 +2813,9 @@ setup_locale_encoding(void)
 			   lc_time);
 	}
 
+	printf(_("The default collation provider is \"%s\".\n"),
+		   get_collprovider_name(collprovider));
+
 	if (!encoding)
 	{
 		int			ctype_enc;
@@ -2662,8 +2866,8 @@ setup_locale_encoding(void)
 	else
 		encodingid = get_encoding_id(encoding);
 
-	if (!check_locale_encoding(lc_ctype, encodingid) ||
-		!check_locale_encoding(lc_collate, encodingid))
+	if (!check_locale_encoding(lc_ctype, encodingid, '\0') ||
+		!check_locale_encoding(lc_collate, encodingid, collprovider))
 		exit(1);				/* check_locale_encoding printed the error */
 
 }
@@ -3439,3 +3643,113 @@ main(int argc, char *argv[])
 
 	return 0;
 }
+
+#ifdef USE_ICU
+/*
+ * If locale is "" return the environment value from setlocale().
+ *
+ * Otherwise return a malloc'd copy of locale if it is not NULL.
+ *
+ * This should match the backend's check_icu_locale() function.
+ */
+static char *
+check_icu_locale_name(const char *locale)
+{
+	char	   *canonname = NULL;
+	char	   *winlocale = NULL;
+	char	   *result;
+
+	/* Windows locales can be in the format ".codepage" */
+	if (locale && (strlen(locale) == 0 || locale[0] == '.'))
+	{
+		check_locale_name(LC_COLLATE, locale, &canonname, COLLPROVIDER_LIBC);
+		locale = (const char *) canonname;
+	}
+
+#ifdef WIN32
+	if (!locale_is_c(locale))
+	{
+		winlocale = check_icu_winlocale(locale);
+
+		if (winlocale == NULL && locale != NULL)
+			exit(1);			/* check_icu_winlocale printed the error */
+		else
+			locale = winlocale;
+	}
+#endif
+
+	result = locale ? pstrdup(locale) : NULL;
+
+	if (canonname)
+		pfree(canonname);
+	if (winlocale)
+		pfree(winlocale);
+
+	return result;
+}
+#endif							/* USE_ICU */
+
+/*
+ * Setup the lc_collate version (get it from the collation provider).
+ */
+static void
+set_collation_version(void)
+{
+	char	   *wincollate = NULL;
+	char	   *langtag = NULL;
+	const char *collate;
+	bool		failure;
+
+	Assert(lc_collate);
+	Assert(is_valid_nondefault_collprovider(collprovider));
+
+	if (collprovider == COLLPROVIDER_ICU)
+	{
+#ifdef USE_ICU
+		collate = (const char *) lc_collate;
+
+#ifdef WIN32
+		if (!locale_is_c(collate))
+		{
+			wincollate = check_icu_winlocale(collate);
+
+			if (wincollate == NULL && collate != NULL)
+				exit(1);		/* check_icu_winlocale printed the error */
+			else
+				collate = (const char *) wincollate;
+		}
+#endif							/* WIN32 */
+
+		langtag = get_icu_language_tag(collate);
+		if (!langtag)
+		{
+			/* get_icu_language_tag printed the main error message */
+			fprintf(stderr, _("Rerun %s with a different locale selection.\n"),
+					progname);
+			exit(1);
+		}
+		collate = get_icu_collate(collate, langtag);
+#else							/* not USE_ICU */
+		fprintf(stderr,
+				_("%s: ICU is not supported in this build\n"
+				  "You need to rebuild PostgreSQL using --with-icu.\n"),
+				progname);
+		exit(1);
+#endif							/* not USE_ICU */
+	}
+	else
+	{
+		/* COLLPROVIDER_LIBC */
+		collate = (const char *) lc_collate;
+	}
+
+	get_collation_actual_version(collprovider, collate, &collversion, &failure);
+	if (failure)
+		/* get_collation_actual_version printed the error */
+		exit(1);
+
+	if (langtag)
+		free(langtag);
+	if (wincollate)
+		free(wincollate);
+}
diff --git a/src/bin/pg_dump/pg_dump.c b/src/bin/pg_dump/pg_dump.c
index c8d01ed4a4..1e56d90260 100644
--- a/src/bin/pg_dump/pg_dump.c
+++ b/src/bin/pg_dump/pg_dump.c
@@ -47,12 +47,14 @@
 #include "catalog/pg_attribute_d.h"
 #include "catalog/pg_cast_d.h"
 #include "catalog/pg_class_d.h"
+#include "catalog/pg_collation.h"
 #include "catalog/pg_default_acl_d.h"
 #include "catalog/pg_largeobject_d.h"
 #include "catalog/pg_largeobject_metadata_d.h"
 #include "catalog/pg_proc_d.h"
 #include "catalog/pg_trigger_d.h"
 #include "catalog/pg_type_d.h"
+#include "common/pg_collation_fn_common.h"
 #include "libpq/libpq-fs.h"
 #include "storage/block.h"
 
@@ -13299,9 +13301,10 @@ dumpCollation(Archive *fout, CollInfo *collinfo)
 	int			i_collprovider;
 	int			i_collcollate;
 	int			i_collctype;
-	const char *collprovider;
+	const char *collproviderstr;
 	const char *collcollate;
 	const char *collctype;
+	const char *collprovider_name;
 
 	/* Skip if not to be dumped */
 	if (!collinfo->dobj.dump || dopt->dataOnly)
@@ -13339,28 +13342,28 @@ dumpCollation(Archive *fout, CollInfo *collinfo)
 	i_collcollate = PQfnumber(res, "collcollate");
 	i_collctype = PQfnumber(res, "collctype");
 
-	collprovider = PQgetvalue(res, 0, i_collprovider);
+	collproviderstr = PQgetvalue(res, 0, i_collprovider);
 	collcollate = PQgetvalue(res, 0, i_collcollate);
 	collctype = PQgetvalue(res, 0, i_collctype);
 
+ 	/*
+	 * Use COLLPROVIDER_DEFAULT to allow dumping pg_catalog; not accepted on
+	 * input
+	 */
+	collprovider_name = get_collprovider_name(collproviderstr[0]);
+	if (!collprovider_name)
+		exit_horribly(NULL,
+					  "unrecognized collation provider: %s\n",
+					  collproviderstr);
+
+
 	appendPQExpBuffer(delq, "DROP COLLATION %s;\n",
 					  fmtQualifiedDumpable(collinfo));
 
 	appendPQExpBuffer(q, "CREATE COLLATION %s (",
 					  fmtQualifiedDumpable(collinfo));
 
-	appendPQExpBufferStr(q, "provider = ");
-	if (collprovider[0] == 'c')
-		appendPQExpBufferStr(q, "libc");
-	else if (collprovider[0] == 'i')
-		appendPQExpBufferStr(q, "icu");
-	else if (collprovider[0] == 'd')
-		/* to allow dumping pg_catalog; not accepted on input */
-		appendPQExpBufferStr(q, "default");
-	else
-		exit_horribly(NULL,
-					  "unrecognized collation provider: %s\n",
-					  collprovider);
+	appendPQExpBuffer(q, "provider = %s", collprovider_name);
 
 	if (strcmp(collcollate, collctype) == 0)
 	{
diff --git a/src/bin/psql/describe.c b/src/bin/psql/describe.c
index 4ca0db1d0c..483bcf208d 100644
--- a/src/bin/psql/describe.c
+++ b/src/bin/psql/describe.c
@@ -17,7 +17,9 @@
 #include "catalog/pg_attribute_d.h"
 #include "catalog/pg_cast_d.h"
 #include "catalog/pg_class_d.h"
+#include "catalog/pg_collation.h"
 #include "catalog/pg_default_acl_d.h"
+#include "common/pg_collation_fn_common.h"
 #include "fe_utils/string_utils.h"
 
 #include "common.h"
@@ -4094,7 +4096,13 @@ listCollations(const char *pattern, bool verbose, bool showSystem)
 
 	if (pset.sversion >= 100000)
 		appendPQExpBuffer(&buf,
-						  ",\n       CASE c.collprovider WHEN 'd' THEN 'default' WHEN 'c' THEN 'libc' WHEN 'i' THEN 'icu' END AS \"%s\"",
+						  ",\n       CASE c.collprovider WHEN '%c' THEN '%s' WHEN '%c' THEN '%s' WHEN '%c' THEN '%s' END AS \"%s\"",
+						  COLLPROVIDER_DEFAULT,
+						  get_collprovider_name(COLLPROVIDER_DEFAULT),
+						  COLLPROVIDER_LIBC,
+						  get_collprovider_name(COLLPROVIDER_LIBC),
+						  COLLPROVIDER_ICU,
+						  get_collprovider_name(COLLPROVIDER_ICU),
 						  gettext_noop("Provider"));
 
 	if (verbose)
diff --git a/src/bin/scripts/Makefile b/src/bin/scripts/Makefile
index 4c6e4b9395..1e80f0b842 100644
--- a/src/bin/scripts/Makefile
+++ b/src/bin/scripts/Makefile
@@ -19,7 +19,7 @@ include $(top_builddir)/src/Makefile.global
 PROGRAMS = createdb createuser dropdb dropuser clusterdb vacuumdb reindexdb pg_isready
 
 override CPPFLAGS := -I$(libpq_srcdir) $(CPPFLAGS)
-LDFLAGS_INTERNAL += -L$(top_builddir)/src/fe_utils -lpgfeutils $(libpq_pgport)
+LDFLAGS_INTERNAL += -L$(top_builddir)/src/fe_utils -lpgfeutils $(libpq_pgport) $(ICU_LIBS)
 
 all: $(PROGRAMS)
 
diff --git a/src/bin/scripts/createdb.c b/src/bin/scripts/createdb.c
index fc108882e4..816e3222f7 100644
--- a/src/bin/scripts/createdb.c
+++ b/src/bin/scripts/createdb.c
@@ -58,6 +58,7 @@ main(int argc, char *argv[])
 	char	   *lc_collate = NULL;
 	char	   *lc_ctype = NULL;
 	char	   *locale = NULL;
+	char	   *canonname = NULL;
 
 	PQExpBufferData sql;
 
@@ -153,7 +154,15 @@ main(int argc, char *argv[])
 					progname);
 			exit(1);
 		}
-		lc_ctype = locale;
+
+		/*
+		 * remove the collation provider modifier from the locale for lc_ctype
+		 */
+		check_locale_collprovider(locale, &canonname, NULL, NULL);
+		if (!canonname)
+			exit(1);		/* check_locale_collprovider printed the error */
+		lc_ctype = canonname;
+
 		lc_collate = locale;
 	}
 
@@ -241,6 +250,9 @@ main(int argc, char *argv[])
 
 	PQfinish(conn);
 
+	if (canonname)
+		pfree(canonname);
+
 	exit(0);
 }
 
diff --git a/src/common/Makefile b/src/common/Makefile
index ec8139f014..6017a250c6 100644
--- a/src/common/Makefile
+++ b/src/common/Makefile
@@ -48,7 +48,7 @@ OBJS_COMMON = base64.o config_info.o controldata_utils.o exec.o file_perm.o \
 	ip.o keywords.o link-canary.o md5.o pg_lzcompress.o \
 	pgfnames.o psprintf.o relpath.o \
 	rmtree.o saslprep.o scram-common.o string.o unicode_norm.o \
-	username.o wait_error.o
+	username.o wait_error.o pg_collation_fn_common.o
 
 ifeq ($(with_openssl),yes)
 OBJS_COMMON += sha2_openssl.o
diff --git a/src/common/pg_collation_fn_common.c b/src/common/pg_collation_fn_common.c
new file mode 100644
index 0000000000..a3ba3a368d
--- /dev/null
+++ b/src/common/pg_collation_fn_common.c
@@ -0,0 +1,90 @@
+/*-------------------------------------------------------------------------
+ *
+ * pg_collation_fn_common.c
+ *	  commmon routines to support manipulation of the pg_collation relation
+ *
+ * Portions Copyright (c) 1996-2017, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ *
+ * IDENTIFICATION
+ *	  src/common/pg_collation_fn_common.c
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifdef FRONTEND
+#include "postgres_fe.h"
+#else
+#include "postgres.h"
+#endif
+
+#include "catalog/pg_collation.h"
+#include "common/pg_collation_fn_common.h"
+
+
+/*
+ * Note that we search the table with pg_strcasecmp(), so variant
+ * capitalizations don't need their own entries.
+ */
+typedef struct collprovider_name
+{
+	char		collprovider;
+	const char *name;
+} collprovider_name;
+
+static const collprovider_name collprovider_name_tbl[] =
+{
+	{COLLPROVIDER_DEFAULT, "default"},
+	{COLLPROVIDER_LIBC, "libc"},
+	{COLLPROVIDER_ICU, "icu"},
+	{'\0', NULL}				/* end marker */
+};
+
+/*
+ * Get the collation provider from the given collation provider name.
+ *
+ * Return '\0' if we can't determine it.
+ */
+char
+get_collprovider(const char *name)
+{
+	int			i;
+
+	if (!name)
+		return '\0';
+
+	/* Check the table */
+	for (i = 0; collprovider_name_tbl[i].name; ++i)
+		if (pg_strcasecmp(name, collprovider_name_tbl[i].name) == 0)
+			return collprovider_name_tbl[i].collprovider;
+
+	return '\0';
+}
+
+/*
+ * Get the name of the given collation provider.
+ *
+ * Return NULL if we can't determine it.
+ */
+const char *
+get_collprovider_name(char collprovider)
+{
+	int			i;
+
+	/* Check the table */
+	for (i = 0; collprovider_name_tbl[i].collprovider; ++i)
+		if (collprovider_name_tbl[i].collprovider == collprovider)
+			return collprovider_name_tbl[i].name;
+
+	return NULL;
+}
+
+/*
+ * Return true if collation provider is nondefault and valid, and false otherwise.
+ */
+bool
+is_valid_nondefault_collprovider(char collprovider)
+{
+	return (collprovider == COLLPROVIDER_LIBC ||
+			collprovider == COLLPROVIDER_ICU);
+}
diff --git a/src/fe_utils/.gitignore b/src/fe_utils/.gitignore
index 37f5f7514d..b14041b5cf 100644
--- a/src/fe_utils/.gitignore
+++ b/src/fe_utils/.gitignore
@@ -1 +1,2 @@
 /psqlscan.c
+/pg_collation_fn_common.c
diff --git a/src/fe_utils/Makefile b/src/fe_utils/Makefile
index 5362cffd57..f6ffa0905b 100644
--- a/src/fe_utils/Makefile
+++ b/src/fe_utils/Makefile
@@ -19,7 +19,8 @@ include $(top_builddir)/src/Makefile.global
 
 override CPPFLAGS := -DFRONTEND -I$(libpq_srcdir) $(CPPFLAGS)
 
-OBJS = mbprint.o print.o psqlscan.o simple_list.o string_utils.o conditional.o
+OBJS = mbprint.o print.o psqlscan.o simple_list.o string_utils.o conditional.o \
+	pg_collation_fn_common.o
 
 all: libpgfeutils.a
 
@@ -33,6 +34,13 @@ psqlscan.c: FLEX_FIX_WARNING=yes
 
 distprep: psqlscan.c
 
+# Pull in pg_collation_fn_common.c from src/common. That exposes us to
+# risks of version skew if we link to a shared library. Do it the
+# hard way, instead, so that we're statically linked.
+
+pg_collation_fn_common.c: % : $(top_srcdir)/src/common/%
+	rm -f $@ && $(LN_S) $< .
+
 # libpgfeutils could be useful to contrib, so install it
 install: all installdirs
 	$(INSTALL_STLIB) libpgfeutils.a '$(DESTDIR)$(libdir)/libpgfeutils.a'
@@ -45,6 +53,7 @@ uninstall:
 
 clean distclean:
 	rm -f libpgfeutils.a $(OBJS) lex.backup
+	rm -f pg_collation_fn_common.c
 
 # psqlscan.c is supposed to be in the distribution tarball,
 # so do not clean it in the clean/distclean rules
diff --git a/src/include/commands/dbcommands.h b/src/include/commands/dbcommands.h
index 677c7fc5fc..d1b27761d4 100644
--- a/src/include/commands/dbcommands.h
+++ b/src/include/commands/dbcommands.h
@@ -29,6 +29,7 @@ extern ObjectAddress AlterDatabaseOwner(const char *dbname, Oid newOwnerId);
 extern Oid	get_database_oid(const char *dbname, bool missingok);
 extern char *get_database_name(Oid dbid);
 
-extern void check_encoding_locale_matches(int encoding, const char *collate, const char *ctype);
+extern void check_encoding_locale_matches(int encoding, const char *collate, const char *ctype,
+										  char collprovider);
 
 #endif							/* DBCOMMANDS_H */
diff --git a/src/include/common/pg_collation_fn_common.h b/src/include/common/pg_collation_fn_common.h
new file mode 100644
index 0000000000..f05778dfad
--- /dev/null
+++ b/src/include/common/pg_collation_fn_common.h
@@ -0,0 +1,22 @@
+/*-------------------------------------------------------------------------
+ *
+ * pg_collation_fn_common.h
+ *	 prototypes for functions in common/pg_collation_fn_common.c
+ *
+ *
+ * Portions Copyright (c) 1996-2017, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/common/pg_collation_fn_common.h
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#ifndef PG_COLLATION_FN_COMMON_H
+#define PG_COLLATION_FN_COMMON_H
+
+extern char get_collprovider(const char *name);
+extern const char *get_collprovider_name(char collprovider);
+extern bool is_valid_nondefault_collprovider(char collprovider);
+
+#endif							/* PG_COLLATION_FN_COMMON_H */
diff --git a/src/include/pg_config.h.win32 b/src/include/pg_config.h.win32
index f7a051d112..a0dd14ebb6 100644
--- a/src/include/pg_config.h.win32
+++ b/src/include/pg_config.h.win32
@@ -686,6 +686,10 @@
 /* Define to use /dev/urandom for random number generation */
 /* #undef USE_DEV_URANDOM */
 
+/* Define to build with ICU support. (--with-icu) */
+/* #undef USE_ICU */
+
+
 /* Define to 1 to build with LDAP support. (--with-ldap) */
 /* #undef USE_LDAP */
 
diff --git a/src/include/port.h b/src/include/port.h
index 3a53bcf2e4..1ddecce5c4 100644
--- a/src/include/port.h
+++ b/src/include/port.h
@@ -473,6 +473,40 @@ extern int	pg_get_encoding_from_locale(const char *ctype, bool write_message);
 extern int	pg_codepage_to_encoding(UINT cp);
 #endif
 
+/* do not make libpq with icu */
+#ifndef LIBPQ_MAKE
+
+extern void check_locale_collprovider(const char *locale, char **canonname,
+									  char *collprovider, char **collversion);
+extern bool locale_is_c(const char *locale);
+extern char *get_full_collation_name(const char *locale, char collprovider,
+									 const char *collversion);
+
+#ifdef FRONTEND
+extern void get_collation_actual_version(char collprovider,
+										 const char *collcollate,
+										 char **collversion, bool *failure);
+#else
+extern char *get_collation_actual_version(char collprovider,
+										  const char *collcollate);
+#endif
+
+#ifdef USE_ICU
+#define ICU_ROOT_LOCALE "root"
+
+/* Users of this must import unicode/ucol.h too. */
+struct UCollator;
+extern struct UCollator *open_collator(const char *collate);
+
+extern char * get_icu_language_tag(const char *localename);
+extern const char *get_icu_collate(const char *locale, const char *langtag);
+#ifdef WIN32
+extern char * check_icu_winlocale(const char *winlocale);
+#endif							/* WIN32 */
+#endif							/* USE_ICU */
+
+#endif							/* not LIBPQ_MAKE */
+
 /* port/inet_net_ntop.c */
 extern char *inet_net_ntop(int af, const void *src, int bits,
 			  char *dst, size_t size);
diff --git a/src/include/port/win32.h b/src/include/port/win32.h
index 9f48a58aed..7e3e7e57e6 100644
--- a/src/include/port/win32.h
+++ b/src/include/port/win32.h
@@ -16,7 +16,7 @@
  * get support for GetLocaleInfoEx() with locales. For everything else
  * the minimum version is Windows XP (0x0501).
  */
-#if defined(_MSC_VER) && _MSC_VER >= 1900
+#if defined(_MSC_VER) && _MSC_VER >= 1800
 #define MIN_WINNT 0x0600
 #else
 #define MIN_WINNT 0x0501
diff --git a/src/include/utils/pg_locale.h b/src/include/utils/pg_locale.h
index 88a3134862..161a14ef61 100644
--- a/src/include/utils/pg_locale.h
+++ b/src/include/utils/pg_locale.h
@@ -57,8 +57,10 @@ extern void assign_locale_numeric(const char *newval, void *extra);
 extern bool check_locale_time(char **newval, void **extra, GucSource source);
 extern void assign_locale_time(const char *newval, void *extra);
 
-extern bool check_locale(int category, const char *locale, char **canonname);
-extern char *pg_perm_setlocale(int category, const char *locale);
+extern bool check_locale(int category, const char *locale, char **canonname,
+						 char collprovider);
+extern const char *pg_perm_setlocale(int category, const char *locale,
+									 char collprovider);
 extern void check_strxfrm_bug(void);
 
 extern bool lc_collate_is_c(Oid collation);
@@ -102,11 +104,11 @@ typedef struct pg_locale_struct *pg_locale_t;
 
 extern pg_locale_t pg_newlocale_from_collation(Oid collid);
 
-extern char *get_collation_actual_version(char collprovider, const char *collcollate);
-
 #ifdef USE_ICU
 extern int32_t icu_to_uchar(UChar **buff_uchar, const char *buff, size_t nbytes);
 extern int32_t icu_from_uchar(char **result, const UChar *buff_uchar, int32_t len_uchar);
+extern const char *get_icu_default_collate(void);
+extern UCollator *get_default_collation_collator(void);
 #endif
 
 /* These functions convert from/to libc's wchar_t, *not* pg_wchar_t */
@@ -115,4 +117,6 @@ extern size_t wchar2char(char *to, const wchar_t *from, size_t tolen,
 extern size_t char2wchar(wchar_t *to, size_t tolen,
 		   const char *from, size_t fromlen, pg_locale_t locale);
 
+extern char get_default_collprovider(void);
+
 #endif							/* _PG_LOCALE_ */
diff --git a/src/interfaces/libpq/.gitignore b/src/interfaces/libpq/.gitignore
index 9be338dec8..7d2e5ce92e 100644
--- a/src/interfaces/libpq/.gitignore
+++ b/src/interfaces/libpq/.gitignore
@@ -3,3 +3,4 @@
 # .c files that are symlinked in from elsewhere
 /encnames.c
 /wchar.c
+/pg_collation_fn_common.c
diff --git a/src/interfaces/libpq/Makefile b/src/interfaces/libpq/Makefile
index c2171d0856..21b5205bb2 100644
--- a/src/interfaces/libpq/Makefile
+++ b/src/interfaces/libpq/Makefile
@@ -19,10 +19,11 @@ NAME= pq
 SO_MAJOR_VERSION= 5
 SO_MINOR_VERSION= $(MAJORVERSION)
 
-override CPPFLAGS :=  -DFRONTEND -DUNSAFE_STAT_OK -I$(srcdir) $(CPPFLAGS) -I$(top_builddir)/src/port -I$(top_srcdir)/src/port
+override CPPFLAGS :=  -DFRONTEND -DUNSAFE_STAT_OK -I$(srcdir) $(CPPFLAGS) -I$(top_builddir)/src/port -I$(top_srcdir)/src/port -DLIBPQ_MAKE
 ifneq ($(PORTNAME), win32)
 override CFLAGS += $(PTHREAD_CFLAGS)
 endif
+LDFLAGS_INTERNAL += $(ICU_LIBS)
 
 # The MSVC build system scrapes OBJS from this file.  If you change any of
 # the conditional additions of files to OBJS, update Mkvcbuild.pm to match.
